<?php

/// Written by David Smith
/// nopeer@gmail.com
///
/// For ATNF CSIRO
///
/// This form presents a login dialog. There are two methods of logging in
/// a) anonymously - you simply enter your email address for identification
/// b) opal        - You provide your username and password for your opal account
///                  In doing so you unlock access to recent data for any of the projects
///                  that opal recognises you as a member for.



require_once GREEN_ZONE_DIR . 'Forms/GZ_BaseForm.php';
require_once 'Classes/General/UserData.php';



class LoginForm extends GZ_BaseForm
{
  var $failure;
  var $user_data;

  function __construct( $set_gz )
  {
    parent::__construct( $set_gz );

    $this->failure = false;

    $this->user_data = new UserData();
  }


  function LoggedIn()
  {
    $logged_in = false;
    
    if( $this->user_data != '' )
    {
      $method = $this->user_data->GetAuthType();
      if( $method == 'anonymous' || $method == 'opal' )
	$logged_in = true;
    }
    
    return $logged_in;
  }


  function Login()
  {
    global $_SESSION;

    if( $this->GetPostString('authenticateType') == 'anon' )
    {
      if( !is_string( $this->GetPostString('email') ) ||
          strlen( $this->GetPostString('email') ) < 4 ||
          strpos( $this->GetPostString('email'), '@' ) === false ||
          strpos( $this->GetPostString('email'), '.' ) === false )
        throw new GZ_Exception( 'Enter a valid email address', 'LoginForm::Login' );

      if( $this->user_data == '' )
        $this->user_data = new UserData();
    
      $this->user_data->SetEmail( $this->GetPostString( 'email' ) );
      $this->user_data->SetAuthType( 'anonymous' );
    }
    else if ( $this->GetPostString('authenticateType') == 'opal' )
    {
        $opal_email = strtolower( $this->GetPostString( 'opalEmail' ) );
        $opal_password = $this->GetPostString( 'opalPassword' );
	$hash = md5( $opal_password );
        
        $opal_db_user = 'authenticator';
        $opal_db_password = 'highintegrity';
        $opal_db_dsn = 'serapis.atnf.csiro.au:1521/atoa.atnf.csiro.au';
        
        $connection = oci_connect( $opal_db_user, $opal_db_password, $opal_db_dsn );
        
        if( $connection === false )
          throw new GZ_Exception( 'Unable to connect to opal database, service may be down!',
                                  'LoginForm::Login' );

	$sql = "SELECT hash FROM opalprod.password p, opalprod.atuser a WHERE a.id = p.userid AND lower(a.email)='".$opal_email."'";

	echo 'sql command is : ' . $sql . ' <br> ';

	$query = oci_parse( $connection, $sql );
	if( $query === false )
		throw new GZ_Exception( 'Unable to create password query', 'LoginForm::Login' );
	
	if( oci_execute( $query, OCI_DEFAULT ) === false )
		throw new GZ_Exception( 'Opal login query failed!', 'LoginForm::Login' );
	
	$row = oci_fetch_array( $query, OCI_RETURN_NULLS );
	if( ! $row )
		echo 'failed to login to opal <br>';
	else
	{
		echo 'from the db ' . $row['HASH'] . ' <br> ';
		echo 'my hash is ' . $hash . ' <br> ';
		echo 'got a row from opal to compare <br>';
		if( $row['HASH'] != $hash )
		{
			echo 'logged in successfully <br>';
		}
		else
		{
			// get a list of all the projects this person is associated with

		}
	}
		
}
  }



  function Logout()
  {
    global $_SESSION;

    if( $this->user_data != '' )
      $this->user_data->RemoveFromSession();
    foreach( $_SESSION as $name => $value )
      unset( $_SESSION[$name] );
  }



  function Display()
  {
    global $_SERVER;

    $smarty = $this->gz->CreateSmarty();

    $logged_in = $this->LoggedIn();
    $proprietary_period = 12;
    $self = $_SERVER['PHP_SELF'];

    $this->gz->smarty_assign( $smarty, 'logged_in', $logged_in );
    $this->gz->smarty_assign( $smarty, 'proprietary_period', $propietary_period );
    $this->gz->smarty_assign( $smarty, 'self', $self );

    $smarty->Display( 'LoginForm.tpl' );
  }


  function ProcessActions()
  {
    if( $this->ActionIs( 'Login' ) )
      $this->Login();
    else if( $this->ActionIs( 'Logout' ) )
      $this->Logout();

    if( $this->LoggedIn() )
      return 'QueryForm';
    else
      return '';
  }
};






?>
